#include<basic.h>
#include<btron/libapp.h>
#include<tcode.h>
#include<tstring.h>
#include<btron/dp.h>
#include<btron/vobj.h>
#include<btron/clk.h>
#include<bstdlib.h>
#include<bstring.h>

/* $B%Q%M%k$K4X$9$kDj5A(B */
/* $B%Q%M%k$K4X$9$kDj5A(B */
#define MAXPITEM 10
#define MAXWIDTH 30

TC scr[] = { TK_S, TK_C, TK_R, TK_E, TK_E, TK_N, TNULL };

TC buf[MAXPITEM * (MAXWIDTH + 1)];
     
TC errormsg[][100] =
     {{ 0x2522, 0x2557, 0x256a, 0x2531, 0x213c, 0x2537, 0x2567, 0x2573,
	0x244e, 0x4550, 0x4f3f, 0x244b, 0x3c3a, 0x4754, 0x2437, 0x245e,
	0x2437, 0x243f, 0x0000 },
	/* 0: $B%"%W%j%1!<%7%g%s$NEPO?$K<:GT$7$^$7$?!#(B */
      { 0x243d, 0x244e, 0x2526, 0x2523, 0x2573, 0x2549, 0x2526, 0x2458,
	0x244e, 0x4a23, 0x3c4c, 0x244f, 0x2447, 0x242d, 0x245e, 0x243b,
	0x2473, 0x2123, 0x0000 },
        /* 1: $B$=$N%&%#%s%I%&$X$NJ#<L$O$G$-$^$;$s!#(B */
      { 0x3c42, 0x3954, 0x3521, 0x473d, 0x4955, 0x6435, 0x244e, 0x3847,
	0x4d2d, 0x2547, 0x213c, 0x253f, 0x242c, 0x4649, 0x2461, 0x245e,
	0x243b, 0x2473, 0x2123, 0x0000 },
        /* 2: $B<B9T5!G=IUd5$N8GM-%G!<%?$,FI$a$^$;$s!#(B */
      { 0x4955, 0x6435, 0x4c3e, 0x242c, 0x405f, 0x446a, 0x2435, 0x246c,
	0x2446, 0x2424, 0x245e, 0x243b, 0x2473, 0x2123, 0x0000 },
        /* 3: $B%a%b%j$N3MF@$K<:GT$7$^$7$?!#(B */
      { 0x347b, 0x244b, 0x4631, 0x306c, 0x2555, 0x2521, 0x2524, 0x256b,
	0x2447, 0x2522, 0x2557, 0x256a, 0x2531, 0x213c, 0x2537, 0x2567,
	0x2573, 0x242c, 0x4550, 0x4f3f, 0x2435, 0x246c, 0x2446, 0x2424,
	0x245e, 0x2439, 0x2123, 0x0000 }
        /* 4: $B4{$KF10l%U%!%$%k$G%"%W%j%1!<%7%g%s$,EPO?$5$l$F$$$^$9!#(B */
};

TC kakunin[] = { MC_STR, 0x334e, 0x4727, 0x0000 }; /* $B3NG'(B */
SWSEL msw = { MS_PARTS, { 0, 0, 70, 24 }, 0, kakunin, 0 };
PNL_ITEM pnlitem[MAXPITEM] = {
    { PARTS_ITEM, 0, { 140, 60, 0, 0 }, 0, 0, (H *)&msw }
};

PANEL errpnl = { 0x0002, 0x0048, 0, { 0, 0, 500, 116}, 1, 1, pnlitem };
PNT pnlpos = { 50, 50 };

TC versionmsg[] = {
    0x2522, 0x2557, 0x256a, 0x2531, 0x213c, 0x2537, 0x2567, 0x2573,
    0x306c, 0x4d77, 0x2376, 0x2365, 0x2372, 0x2332, 0x2125, 0x2331,
    TK_NL,
    0x3a6e, 0x402e, 0x467c, 0x3b7e, 0x2121, 0x2339, 0x2338, 0x213f,
    0x2331, 0x2331, 0x213f, 0x2331, 0x2333, 0x0000 };
    /* $B%"%W%j%1!<%7%g%s0lMw#v#e#r#2!%#1(B */
    /* $B:n@.F|;~!!#9#8!?#1#1!?#1#3(B */

void msgpanel();

void printerror(W errno)
{
    msgpanel(errormsg[errno]);
}

void msgpanel(TC *tc)
{
    W i, j, maxw, pid, itemno, sts;
    EVENT evt;
    TC    *pt, *pt2;
    DEV_SPEC ds;

    pt   = tc;
    pt2  = buf;
    maxw = 10;
    for (i = 1 ; ((i < MAXPITEM) && (pt != NULL)) ; i++) {
	pnlitem[i].itype = TEXT_ITEM;
	pnlitem[i].info  = 0;
	pnlitem[i].desc  = 0;
	pnlitem[i].dnum  = 0;
	pnlitem[i].ptr   = pt2;
	for (j = 1 ;; j++) {
	    switch (*(pt2++) = *(pt++)) {
	    case TNULL:
		pt = NULL;
		break;
	    case TK_NL:
		*(pt2 - 1) = TNULL;
		break;
	    default:
		if (i < MAXWIDTH) {
		    continue;
		}
		else {
		    *(pt2++) = TNULL;
		    break;
		}
	    }
	    break;
	}
	pnlitem[i].ir.c.left   = 30;
	pnlitem[i].ir.c.top    = 20 * i + 10;
	pnlitem[i].ir.c.right  = 30 + 16 * j;
	pnlitem[i].ir.c.bottom = 20 * i + 26;
	if (maxw < j) {
	    maxw = j;
	}
    }    
    errpnl.nitem = i;
    errpnl.r.c.right  = 40 + 16 * maxw;
    errpnl.r.c.bottom = 70 + 20 * i;

    pnlitem[0].ir.c.left = 20 + (16 * maxw - 70) / 2;
    pnlitem[0].ir.c.top  = 20 * i + 20;

    gget_spc(scr, &ds);
    pnlpos.x = (ds.hpixels - errpnl.r.c.right) / 2;
    pnlpos.y = (ds.vpixels - errpnl.r.c.bottom) / 2;
   
    pid = pcre_pnl(&errpnl, &pnlpos);
    do {
	sts = pact_pnl(pid, &evt, &itemno);
    } while (!(((sts & P_CHANGE) && (itemno == 1)) || (itemno == -1)));
    pdel_pnl(pid);
}

void printversion()
{
    msgpanel(versionmsg);
}

